#!/usr/bin/env python
import gobject
import sys
try:
 	import pygtk
  	pygtk.require("2.0")
except:
  	pass
try:
	import gtk
  	import gtk.glade
except:
	sys.exit(1)




class HellowWorldGTK:
	"""This is an Hello World GTK application"""

	def __init__(self):
		#self.personajes=["hola","medio","adios"]
                self.personajes=[]
                self.fondos=[]
		self.animaciones=[]
		self.escena=[]
		self.posfondos={}
		self.posiciones=["Izquierda","Centro","Derecha"]
		#self.animaciones["hola"]={}
		#self.animaciones["hola"]["adios"]="pepe"
		#self.animaciones["hola"]["riendo"]="pepe"
		#self.animaciones["hola"]["llorando"]="pepe"
                self.indPersonajes=0
                self.indAnimacion=0
                self.indFondos=0
                self.indPos=0
                
		#Set the Glade file
		self.gladefile = "glade/Editor2d.glade"  
	        self.wTree = gtk.glade.XML(self.gladefile)
	        #recojo las ventanas
	        self.mainwindow=self.wTree.get_widget("MainWindow")
	        self.ventanapersonaje=self.wTree.get_widget("Wpers")
	        self.ventanaanimacion=self.wTree.get_widget("Wani")
	        self.ventanafondo=self.wTree.get_widget("Wfondo")
	        self.ventanatexto=self.wTree.get_widget("Wtext")
	        #fin de recoger ventanas

                #oculto todas las ventanas menos la principal
                self.ventanapersonaje.hide()
                self.ventanaanimacion.hide()
                self.ventanafondo.hide()
                self.ventanatexto.hide()
                #fin de la ocultacion

                #copio los botones de la pantalla principal
                self.Ipers=self.wTree.get_widget("button4")
                self.Dpers=self.wTree.get_widget("button5")
                self.Iani=self.wTree.get_widget("button6")
                self.Dani=self.wTree.get_widget("button7")
                self.Ifondo=self.wTree.get_widget("button8")
                self.Dfondo=self.wTree.get_widget("button9")
                self.botonG=self.wTree.get_widget("botonG")
                self.setFondo=self.wTree.get_widget("Insfondo")
                #me quedo con los 3 labels 
                self.PersLabel=self.wTree.get_widget("label7")
                self.AniLabel=self.wTree.get_widget("label8")
                self.FondoLabel=self.wTree.get_widget("label9")
                self.PosLabel=self.wTree.get_widget("labelPosicion")
                #botones para ir a las distintas ventanas
                self.Apers=self.wTree.get_widget("Apers")
                self.Aani=self.wTree.get_widget("Aani")
                self.Afondo=self.wTree.get_widget("Afondo")
                self.Atexto=self.wTree.get_widget("Itext")
                #botones para volver de las distinas ventanas
                self.Vpers=self.wTree.get_widget("Vpers")
                self.Vani=self.wTree.get_widget("Vani")
                self.Vfondo=self.wTree.get_widget("Vfondo")
                self.Vtexto=self.wTree.get_widget("Vtext")

                #cojo los cuadros de texto
                self.persT=self.wTree.get_widget("Tpers")
                self.aniT=self.wTree.get_widget("entry1")
                self.aniT2=self.wTree.get_widget("entry2")
                self.fondoT=self.wTree.get_widget("entry3")
                self.fondoT2=self.wTree.get_widget("entry4")
                self.textoT=self.wTree.get_widget("entry5")

                self.PosLabel.set_text(self.posiciones[self.indPos]);


                #self.combopers.append_text("text")
                #self.combopers.
                #self.modelo = gtk.ListStore(gobject.TYPE_STRING)
                #self.mainwindow.show();
	        #self.label=self.wTree.get_widget("label1")
		#Create our dictionay and connect it
		#dic = { "on_btnHelloWorld_clicked" : self.btnHelloWorld_clicked,
			#"on_MainWindow_destroy" : gtk.main_quit }

                dic = { "on_MainWindow_destroy" : gtk.main_quit,"Insfondoc":self.Insfondocf,"posAntc" : self.posAntcf,"posSigc" : self.posSigcf,"botonGc":self.botonGcf,"boton4c" : self.boton4,"boton5c" : self.boton5,"boton6c" : self.boton6,"boton7c" : self.boton7 ,"boton8c" : self.boton8,"boton9c" :self.boton9,"Apersc": self.Apersf,"Aanic":self.Aanif,"Afondoc":self.Afondof,"Vpersc": self.Vpersf,"Vanic":self.Vanif,"Vfondoc":self.Vfondof,"Atextoc":self.Atextof,"Vtextoc":self.Vtextof  }
		self.wTree.signal_autoconnect(dic)

	def btnHelloWorld_clicked(self, widget):
                self.label.set_text("funciona")
		print "Hello World!"

        def Insfondocf(self, widget):
            if (len(self.fondos)>0):
                self.posfondos[str(len(self.escena))]=self.fondos[self.indFondos][0]
            print "funciona"
        def posAntcf(self, widget):
            self.indPos-=1
            self.indPos=self.indPos%3
            self.PosLabel.set_text(self.posiciones[self.indPos]);
        def posSigcf(self, widget):
            self.indPos-=1
            self.indPos=self.indPos%3
            self.PosLabel.set_text(self.posiciones[self.indPos]);       
        def boton4(self, widget):
            self.indPersonajes-=1;
            if(len(self.personajes)>0):
                self.AniLabel.set_text("")
                self.indAnimacion=0
                self.indPersonajes=self.indPersonajes%len(self.personajes)
                self.PersLabel.set_text(self.personajes[self.indPersonajes])

        def boton5(self, widget):
            self.indPersonajes+=1;
            if(len(self.personajes)>0):
                self.AniLabel.set_text("")
                self.indAnimacion=0
                self.indPersonajes=self.indPersonajes%len(self.personajes)
                self.PersLabel.set_text(self.personajes[self.indPersonajes])
                
        def boton6(self, widget):
            self.indAnimacion-=1;
            if(len(self.personajes)>0):
                if(len(self.animaciones[self.indPersonajes])>0):
                    self.indAnimacion=self.indAnimacion%len(self.animaciones[self.indPersonajes])
                    self.AniLabel.set_text(self.animaciones[self.indPersonajes][self.indAnimacion][0])
                    
        def boton7(self, widget):
            self.indAnimacion+=1;
            if(len(self.personajes)>0):
                if(len(self.animaciones[self.indPersonajes])>0):
                    self.indAnimacion=self.indAnimacion%len(self.animaciones[self.indPersonajes])
                    self.AniLabel.set_text(self.animaciones[self.indPersonajes][self.indAnimacion][0])
                    
        def boton8(self, widget):
            self.indFondos-=1;
            if(len(self.fondos)>0):
                self.indFondos=self.indFondos%len(self.fondos)
                self.FondoLabel.set_text(self.fondos[self.indFondos][0])
                
        def boton9(self, widget):
            self.indFondos+=1;
            if(len(self.fondos)>0):
                self.indFondos=self.indFondos%len(self.fondos)
                self.FondoLabel.set_text(self.fondos[self.indFondos][0])
                
        def Apersf(self, widget):
            self.mainwindow.hide()
            self.ventanapersonaje.show()
        def Afondof(self, widget):
            self.mainwindow.hide()
            self.ventanafondo.show()
        def Aanif(self, widget):
            self.mainwindow.hide()
            self.ventanaanimacion.show()

        def Atextof(self, widget):
            self.mainwindow.hide()
            self.ventanatexto.show()


        def Vpersf(self, widget):
            var=self.persT.get_text()
            self.personajes.append(var)
            self.animaciones.append("")
            self.animaciones[len(self.personajes)-1]=[]
            self.PersLabel.set_text(self.personajes[self.indPersonajes])
            self.mainwindow.show()
            self.ventanapersonaje.hide()
            
        def Vfondof(self, widget):

            aux=self.fondoT.get_text()
            aux2=self.fondoT2.get_text()
            aux3=(aux,aux2)
            self.fondos.append("")
            self.fondos[len(self.fondos)-1]=aux3
            self.FondoLabel.set_text(self.fondos[self.indFondos][0])
            self.mainwindow.show()
            self.ventanafondo.hide()
            
        def Vanif(self, widget):
            if(len(self.personajes)>0):
                aux=self.aniT.get_text()
                aux2=self.aniT2.get_text()
                aux3=(aux,aux2)       
                self.animaciones[self.indPersonajes].append(aux)
                self.animaciones[self.indPersonajes][len(self.animaciones[self.indPersonajes])-1]=aux3
                self.AniLabel.set_text(self.animaciones[self.indPersonajes][len(self.animaciones[self.indPersonajes])-1][0])
            self.mainwindow.show()
            self.ventanaanimacion.hide()

        def Vtextof(self, widget):
            aux=self.textoT.get_text()
            aux2=self.personajes[self.indPersonajes]
            aux3=self.animaciones[self.indPersonajes][self.indAnimacion][0]
            aux4=self.posiciones[self.indPos]
            auxT=(aux2,aux3,aux,aux4)
            self.escena.append("")
            self.escena[len(self.escena)-1]=auxT
            print self.escena
            self.mainwindow.show()
            self.ventanatexto.hide()
            
        def botonGcf(self, widget):
            file = open('test.log', 'w')
            #escribo la parte de las casas
            for i in self.fondos:
                file.write(i[0])
                file.write("\n")
                file.write(i[1])
                file.write("\n")
            file.write("\n")
            #escribo la parte de los personajes y sus animaciones
            for i in range(len(self.personajes)):
                file.write(self.personajes[i])
                file.write("\n")
                file.write(str(len(self.animaciones[i])))
                file.write("\n")                
                for j in range(len(self.animaciones[i])):                   
                    file.write(self.animaciones[i][j][0])
                    file.write("\n")                    
                    file.write(self.animaciones[i][j][1])
                    file.write("\n")                    
            file.write("\n") 

            #escribo el texto
            for i in range(len(self.escena)):
                if( str(i) in self.posfondos.keys()):
                    file.write(self.posfondos[str(i)])
                    file.write("\n")
                file.write(self.escena[i][0])
                file.write("\n")
                file.write(self.escena[i][3])
                file.write("\n")
                file.write(self.escena[i][1])
                file.write("\n")
                file.write(self.escena[i][2])
                file.write("\n")


            file.close()
            print "guardando"
            
if __name__ == "__main__":
	hwg = HellowWorldGTK()
	gtk.main()
